



<!DOCTYPE html><html lang=zh-CN><head><meta http-equiv="Content-Type" content="text/html; charset=utf-8" /><meta http-equiv="X-UA-Compatible" content="IE=edge,chrome=1"><meta name="applicable-device" content="pc,mobile"><meta name="renderer" content="webkit"><meta name="viewport" content="width=device-width,initial-scale=1.0,maximum-scale=5,viewport-fit=cover">
<title>git 入门教程之紧急修复</title>	
<script src="//n4.ikafan.com/assets/run_prettify.js?ac"></script>
<link rel="stylesheet" href="//n4.ikafan.com/assetsg/style.css">
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/fontello.css?ac"> -->
<!-- <link rel="stylesheet" href="//pic.ikafan.com/staticx/shuzhiduo/1/css.grace/animation.css?ac"> -->
<script>
var _hmt = _hmt || [];
(function() {
  var hm = document.createElement("script");
  hm.src = "https://hm.baidu.com/hm.js?c61d51e9fdcf1d1631ddfce8df9cd119";
  var s = document.getElementsByTagName("script")[0]; 
  s.parentNode.insertBefore(hm, s);
})();
</script>
<script src="https://n4.ikafan.com/g/show.js"></script>

</head>
<div id="header" class="navbar navbar-default navbar-fixed-top header-01">
	<div class="container">
		<h1 class="logo">
			<a  href="/" title="巴特西"/>
							巴特西
			</a>
		</h1>
				<div role="navigation"  class="site-nav  primary-menu">
			<div class="menu-fix-box">
				 <ul id="menu-navigation" class="menu" >
<li><a href="/">首页</a></li>
<!-- <li><a href="/search/Hadoop/">Hadoop</a></li>
<li><a href="/search/Linux/">Linux</a></li>
<li><a href="/search/jQuery/">jQuery</a></li> -->
<li><a href="/search/Python/">Python</a></li>
<li><a href="/search/Java/">Java</a></li>
<li><a href="/search/PHP/">PHP</a></li>
<li><a href="/search/IOS/">IOS</a></li>
<li><a href="/search/Andorid/">Andorid</a></li>
<li><a href="/search/NodeJS/">NodeJS</a></li>
<li><a href="/search/JavaScript/">JavaScript</a></li>
<li><a href="/search/HTML5/">HTML5</a></li>
				</ul>					 			
			</div>
		</div>
				<!--<div class="right-nav">
				<button class="js-toggle-search"><i class="icon-search"></i></button>
		</div>-->
       
			</div>	
</div>

<div id="page-content">
	<div class="container">
		<div class="row">
			
			<div class="blog-post">
								<!--<div class="posts-top-cjtz clearfix"></div>-->
								<div class="post">
										<div class="post-title">
											<div id="title_top"></div>
<script>insertAdIfNeeded();</script>
						<h1 class="title">git 入门教程之紧急修复</h1>
						<div class="post_icon">
							<span class="icon-clock-1"> 2024-02-03 00:13:02 </span>
						</div>
										<div class="post-content">
													<div id="single_top"></div>
<script>insertAdIfNeeded();</script>
											
		<p>和往常一样,每个人团队开发者都在自己的本地分支上进行日常工作,相互独立又相互联系,一直以来相安无事,可是某天下午,上级领导突然急冲冲的打电话告诉你线上出<code>bug</code>了,需要你紧急修复,下班之前必须解决!</p>
<p>我们天生就是创造 <code>bug</code> 的特殊群体,每天都在和各种各样的 <code>bug</code> 打交道,早已经习惯了这样的工作节奏,再也没有当初刚刚遇到紧急问题的手足无措,先喝杯茶,冷静一下,然后汇报领导说:放心吧!保证<code>30min</code> 内解决问题!</p>
<h2>背景</h2>
<p>学习了分支操作的相关知识,团队内部就基本的开发流程达成一致:</p>
<p>假设线上是主干 <code>master</code> 分支,开发是 <code>dev</code> 分支,团队成员是自定义 <code>custom</code> 分支,平时开发时在大家在各自 <code>custom</code> 分支上工作,完成分配任务后再合并到开发 <code>dev</code> 分支,等到开发分支功能稳定后,由项目领导负责合并到主干分支 <code>master</code> .</p>
<blockquote><p>上述流程只是开发流程的简化版,实际情况更加复杂,后续再介绍 <code>gitflow</code> 工作流相关知识.</p></blockquote>
<p>由于是线上出现 <code>bug</code>,理所当然是基于 <code>master</code> 分支检出临时分支,修复分支代号为 <code>issue-110</code>,然后定位 <code>bug</code> 并提交,最后再合并到 <code>master</code> 分支,如此一来成功修复 <code>bug</code>,完成既定任务,心安理得准备下班回家!</p>
<p>如果真的向上述步骤那样操作,显然还不够冷静,刚才那一杯茶算是白喝了!因为这样操作可能会丢失现场数据,那很多工作岂不是白做了,下面简单演示一下:</p>
<h3>错误示例</h3>
<p>(一). 事发前正在自定义的 <code>snow</code> 分支上愉快编码中...</p>
<pre class="prettyprint linenums"><code># 线上分支 `master`,开发分支 `dev`,自定义分支 `snow`,当前正处于自定义分支<br />
$ git branch<br />
  dev<br />
  master<br />
* snow<br />
# 接到领导电话前正在自定义 `snow` 分支上进行愉快编码中...<br />
$ echo &quot;Happy coding&quot; &gt;&gt; test.txt<br />
$ git add test.txt<br />
$ git commit -m  &quot;Happy coding&quot;<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/16648241-f2c0224f12ed56c4.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>
<p>(二). 事发时直接检出主分 <code>master</code> 分支,并紧急修复 <code>bug</code> .</p>
<p>(2.1) 基于 <code>master</code> 分支检出 <code>issue-110</code> 分支,并修复提交.</p>
<pre class="prettyprint linenums"><code># 注意: 事发时正在思考人生,此时更改尚未添加到暂存区!<br />
$ echo &quot;who am i&quot; &gt;&gt; test.txt

# 当前情况下,默认不允许直接切换到其他分支,因为工作区更改会被重写,这里为了演示错误示例,强制切换!<br />
$ git checkout -f master 

# 基于主干 `master` 分支检出修复 `issue-110`分支<br />
$ git checkout -b issue-110<br />
Switched to a new branch 'issue-110'

# 定位线上 `bug`并修复,假设将 `fast forward` 更改为 `fast forward not recommend`,瞬间修复 `bug`有没有!<br />
$ cat test.txt<br />
add test.txt<br />
see https://snowdreams1006.github.io/git/usage/remote-repository.html<br />
learn git branch<br />
see https://snowdreams1006.github.io/git/usage/branch-overview.html<br />
git commit c1<br />
git commit c2 and c3<br />
git checkout -b dev<br />
fast forward<br />
$ vim test.txt<br />
$ cat test.txt<br />
add test.txt<br />
see https://snowdreams1006.github.io/git/usage/remote-repository.html<br />
learn git branch<br />
see https://snowdreams1006.github.io/git/usage/branch-overview.html<br />
git commit c1<br />
git commit c2 and c3<br />
git checkout -b dev<br />
fast forward not recommend

# 修复 `bug` 后,提交更改并备注已修复<br />
$ git add test.txt<br />
$ git commit -m &quot;fix bug about issue-110&quot;<br />
[issue-110 e60c8ad] fix bug about issue-110<br />
 1 file changed, 1 insertion(+), 1 deletion(-)<br />
sunpodeMacBook-Pro:git-demo sunpo$ git status<br />
On branch issue-110<br />
nothing to commit, working tree clean<br />
$<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/16648241-d06d550b63472656.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>
<p>(2.1) 切换到主干 <code>master</code> 分支,并合并修复 <code>issue-110</code> 分支</p>
<pre class="prettyprint linenums"><code># 切换回 `master` 分支,合并修复 `issue-110` 分支<br />
$ git checkout master<br />
Switched to branch 'master'<br />
Your branch is up to date with 'origin/master'.<br />
$ git merge issue-110<br />
Updating 3fe94c0..e60c8ad<br />
Fast-forward<br />
 test.txt | 2 +-<br />
 1 file changed, 1 insertion(+), 1 deletion(-)

# 验证 `bug` 已修复: 更改为 `fast forward not recommend`<br />
$ cat test.txt<br />
add test.txt<br />
see https://snowdreams1006.github.io/git/usage/remote-repository.html<br />
learn git branch<br />
see https://snowdreams1006.github.io/git/usage/branch-overview.html<br />
git commit c1<br />
git commit c2 and c3<br />
git checkout -b dev<br />
fast forward not recommend<br />
$<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/16648241-ba7cb11cfb137340.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>
<p>(三). 事发后切换回自定义 <code>snow</code> 分支,打算下班回家.</p>
<pre class="prettyprint linenums"><code># 切换回 `snow` 分支,发现丢失了事发前的未保存更改:`who am i`<br />
$ git checkout snow<br />
Switched to branch 'snow'<br />
$ cat test.txt<br />
add test.txt<br />
see https://snowdreams1006.github.io/git/usage/remote-repository.html<br />
learn git branch<br />
see https://snowdreams1006.github.io/git/usage/branch-overview.html<br />
git commit c1<br />
git commit c2 and c3<br />
git checkout -b dev<br />
fast forward<br />
Happy coding<br />
$<br />
</code></pre>
<p><img referrerpolicy="no-referrer"src="https://upload-images.jianshu.io/upload_images/16648241-0276f21f0f9eb6e8.png?imageMogr2/auto-orient/strip%7CimageView2/2/w/1240"></p>
<blockquote><p>现在还打算下班吗?你所做的更改因为没有提交或者不能提交造成全部丢失!</p></blockquote>
<h4>结果</h4>
<p>因为手头工作进行到一半无法提交或者忘记提交等原因,为了临时修复紧急 <code>bug</code> 而<strong>直接切换</strong>到目标分支再回来时发现更改全部丢失,相当于那部分工作白忙活了!</p>
<h3>正确示例</h3>
<p>经过上述错误示例的惨痛教训后,再也不敢轻易切换分支了,原因在于工作区更改并没有被提交,或者说不能提交,如果能够有一种机制来保护案发现场,这样我们就能放心切换到其他分支工作,回来时一切如初,那该多好?</p>
<p>幸运的是,<code>git</code> 确实提供这么一种机制,<code>git stash</code> 命令临时存储工作区,类似&quot;草稿箱&quot;作用.</p>
<p>(一). 恢复工作区丢失更改,并使用 <code>git stash</code> 命令保存现场.</p>
<pre class="prettyprint linenums"><code># 修复工作区丢失更改: 同样未添加到暂存区<br />
$ echo &quot;learn git stash&quot; &gt;&gt; test.txt<br />
$ cat test.txt<br />
add test.txt<br />
see https://snowdreams1006.github.io/git/usage/remote-repository.html<br />
learn git branch<br />
see https://snowdreams1006.github.io/git/usage/branch-overview.html<br />
git commit c1<br />
git commit c2 and c3<br />
git checkout -b dev<br />
fast forward<br />
Happy coding<br />
learn git stash

# 保护现场: 存储到&quot;草稿箱&quot;<br />
$ git stash<br />
Saved working directory and index state WIP on snow: 93227ba Happy coding<br />
</code></pre>
<p>(二). 切换到开发 <code>dev</code> 分支并合并修复 <code>issue-110</code> 分支.</p>
<pre class="prettyprint linenums"><code># 切换到开发 `dev` 分支<br />
$ git checkout dev<br />
Switched to branch 'dev'<br />
sunpodeMacBook-Pro:git-demo sunpo$ git status<br />
On branch dev<br />
nothing to commit, working tree clean<br />
# 合并修复 `issue-110` 分支<br />
$ git merge issue-110<br />
Updating 3fe94c0..e60c8ad<br />
Fast-forward<br />
 test.txt | 2 +-<br />
 1 file changed, 1 insertion(+), 1 deletion(-)<br />
sunpodeMacBook-Pro:git-demo sunpo$ git status<br />
On branch dev<br />
nothing to commit, working tree clean<br />
$<br />
</code></pre>
<p>(三). 切换回自定义 <code>snow</code> 分支,并恢复工作现场.</p>
<pre class="prettyprint linenums"><code># 切换回自定义 `snow` 分支<br />
$ git checkout snow<br />
Switched to branch 'snow'<br />
sunpodeMacBook-Pro:git-demo sunpo$ git status<br />
On branch snow<br />
nothing to commit, working tree clean<br />
$<br />
</code></pre>
<p><code>git status</code> 命令返回结果怎么显示工作区是干净的,好不容易才将丢失的更改找回来怎么又不见了?!逗我玩?</p>
<p>冷静,冷静,不要慌,既然工作现场已经保存到&quot;草稿箱&quot;,那我们想要找回总要去&quot;草稿箱&quot;才能取出来吧?现在让我们看一下&quot;草稿箱&quot;有没有我们的工作现场?</p>
<pre class="prettyprint linenums"><code># 查看存储的&quot;草稿箱&quot;列表<br />
$ git stash list<br />
stash@{0}: WIP on snow: 93227ba Happy coding<br />
$<br />
</code></pre>
<blockquote><p>这里的 <code>stash@{0}</code> 是草稿 id,因为&quot;草稿箱&quot;允许保存多条草稿!</p></blockquote>
<p>现在放心了吧,保存的&quot;草稿&quot;安然无恙躺在未知的某个地方,现在我们想办法恢复回工作区即可!</p>
<ul><li><code>git stash apply</code> 恢复草稿,然后 <code>git stash drop</code> 删除草稿</li>
<li><code>git stash pop</code> 恢复并删除草稿</li></ul>
<pre class="prettyprint linenums"><code># 恢复工作现场<br />
$ git stash pop<br />
On branch snow<br />
Changes not staged for commit:<br />
  (use &quot;git add &lt;file&gt;...&quot; to update what will be committed)<br />
  (use &quot;git checkout -- &lt;file&gt;...&quot; to discard changes in working directory)

    modified:   test.txt

no changes added to commit (use &quot;git add&quot; and/or &quot;git commit -a&quot;)<br />
Dropped refs/stash@{0} (b0c8ddc034d21f31204c82e9838fc5d4c01a49a8)

# 工作现场已恢复,更改未添加到暂存区,`learn git stash` 又恢复了!<br />
$ git status<br />
On branch snow<br />
Changes not staged for commit:<br />
  (use &quot;git add &lt;file&gt;...&quot; to update what will be committed)<br />
  (use &quot;git checkout -- &lt;file&gt;...&quot; to discard changes in working directory)

    modified:   test.txt

no changes added to commit (use &quot;git add&quot; and/or &quot;git commit -a&quot;)<br />
$ cat test.txt<br />
add test.txt<br />
see https://snowdreams1006.github.io/git/usage/remote-repository.html<br />
learn git branch<br />
see https://snowdreams1006.github.io/git/usage/branch-overview.html<br />
git commit c1<br />
git commit c2 and c3<br />
git checkout -b dev<br />
fast forward<br />
Happy coding<br />
learn git stash<br />
</code></pre>
<h4>结果</h4>
<p>不论手头工作有没有提交,一旦工作区保存到&quot;草稿箱&quot;后,就放心大胆切换分支进行工作,回来时岁月静好,一切如初!</p>
<h2>小结</h2>
<p>紧急修复 <code>bug</code> 时,可以通过 <code>git stash</code> 保护工作现场,然后再切换到目标分支,检出修复分支,完成修复后切换到目标分支,合并修复分支,最后删除修复分支,此时再切换回本地分支后一切如初!</p>
<ul><li>工作区更改添加到&quot;草稿箱&quot; :  <code>git stash</code>,支持多次添加到&quot;草稿箱&quot;</li>
<li>列出&quot;草稿箱&quot;内容 : <code>git stash list</code></li>
<li>恢复&quot;草稿箱&quot;内容 : <code>git stash apply</code></li>
<li>删除&quot;草稿箱&quot;内容 : <code>git stash drop</code></li>
<li>恢复并删除&quot;草稿箱&quot;内容 : <code>git stash pop</code></li>
<li>恢复|删除指定&quot;草稿箱&quot;内容 : <code>git stash &lt;stash-id&gt;</code>,例如 <code>git stash apply stash@{0}</code></li></ul>												<div id="single_bottom"></div>
<script>insertAdIfNeeded();</script>
																
<h2>最新文章</h2>	
<ol>
						<li><a href="https://www.batexi.com/a/49gp0n79.html">NOIP2012同余方程&lbrack;exgcd&rsqb;</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qxoj1dq.html">走进spring之springmvc实战篇（一）</a>
		</li>
						<li><a href="https://www.batexi.com/a/5qyrrpd8.html">laravel 安装完成后安装 vendor 目录</a>
		</li>
						<li><a href="https://www.batexi.com/a/m96e77yq.html">&lbrack;推荐&rsqb;Bitnami 开源软件包安装解决方案</a>
		</li>
						<li><a href="https://www.batexi.com/a/o8omo7pq.html">CSS 指定选择器&lpar;十一&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/rqlgxek9.html">Git&period;Framework 框架随手记--ORM查询数据集合 一</a>
		</li>
						<li><a href="https://www.batexi.com/a/93x1x1g9.html">xcode5 ios7升级后的一系列问题解决</a>
		</li>
						<li><a href="https://www.batexi.com/a/8mn3jopq.html">python随机产生4个互不相等的随机数</a>
		</li>
						<li><a href="https://www.batexi.com/a/8eyylnk9.html">KMP该算法解释&lpar;最长公共子&rpar;</a>
		</li>
						<li><a href="https://www.batexi.com/a/qy14x2dq.html">python 日期格式化常用标记</a>
		</li>
						<li><a href="https://www.batexi.com/a/9pd74rd9.html">Day3 文件操作和函数</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwjz2ok8.html">教育改革&mdash;&mdash;国家认证 &OpenCurlyDoubleQuote;网红&rdquo; 编程语言 Python</a>
		</li>
						<li><a href="https://www.batexi.com/a/90mo61o8.html">centos7中设置nginx的systemctl启动方式</a>
		</li>
						<li><a href="https://www.batexi.com/a/qwvlvey8.html">Copy Control settings</a>
		</li>
						<li><a href="https://www.batexi.com/a/qv2kk1x9.html">python逻辑运算符规则</a>
		</li>
						<li><a href="https://www.batexi.com/a/qxdzdkv9.html">JavaScript&colon; Constructor and Object Oriented Programming</a>
		</li>
						<li><a href="https://www.batexi.com/a/95g72mmq.html">Java学习笔记42（序列化流）</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1rd4wz8.html">NIO 学习笔记三：DatagramChannel</a>
		</li>
						<li><a href="https://www.batexi.com/a/q1r6jo28.html">【Hive学习之一】Hive简介</a>
		</li>
						<li><a href="https://www.batexi.com/a/q2k067vq.html">HDU1024 最大M子段和问题 （单调队列优化）</a>
		</li>
		</ol>
	

<h2>热门文章</h2>	
<ol>
									<li><a href="https://www.batexi.com/a/9pwwv1d8.html">Java内存溢出异常（下）</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvv0yk8.html">NuGet 构建服务器与常用命令</a>
			</li>
						<li><a href="https://www.batexi.com/a/8o11o0pq.html">ionic3项目 出现 No provider for ApplicationInitStatus&excl;</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvvenk8.html">mysql 开发进阶篇系列 2 SQL优化&lpar;explain分析&rpar;</a>
			</li>
						<li><a href="https://www.batexi.com/a/90rrx0j9.html">设计模式之装饰模式，session共享的底层原理</a>
			</li>
						<li><a href="https://www.batexi.com/a/qxdd3yd9.html">Go语言学习笔记&lpar;三&rpar; &lbrack;控制结构、内建函数&rsqb;</a>
			</li>
						<li><a href="https://www.batexi.com/a/8zyyzl19.html">SHELL脚本--简介</a>
			</li>
						<li><a href="https://www.batexi.com/a/qnvvxx38.html">Perl导入代码文件</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvv2pk8.html">shell编程基础&lpar;四&rpar;&colon; shell脚本语法之函数及调试</a>
			</li>
						<li><a href="https://www.batexi.com/a/qwvv3lz8.html">Entity Framework Core 中文入门文档</a>
			</li>
			</ol>			
							
					</div>

					
<div class="next-prev-posts clearfix">
</div>
						 
				</div>
				
	<div class="clear"></div>

			</div>	
			

		</div>
</div>
</div>


<div class="clearfix"></div>
<div id="footer" class="two-s-footer">
	<div class="footer-box">
		<div class="container">
			<div class="row" style="padding-left: 15px;padding-right: 15px;">
			<div class="nav-footer">
				<a href="/">Home</a>
				</div>
				<div class="copyright-footer">
					<p>Powered By WordPress</p>
				</div>
							</div>
		</div>
	</div>
</div>
<div style="display:none">

</div>
<script src="//n4.ikafan.com/assets/js/echo.js"></script>
<script>
    echo.init({
      offset: 100,
      throttle: 250,
      unload: false,
      callback: function (element, op) {
        console.log(element, 'has been', op + 'ed')
      }
    });
 </script>
</body>
</html>
